﻿/*	AVAILABLE DATA
	thisCommand_obj
		data						This command's data
		run()						This function
		nextEvent()			Function that triggers the next sibling command
		storeTimeout()	Function that stores this command's timeout ID   (used to stop the script)
			var waitId = setTimeout( parentScript.nextEvent, thisCommand_obj.data.value*1000 );
			thisCommand_obj.storeTimeout( waitId );
*/
//#include "gameFunctions/getPathValue.as"
//#include "gameProgram/parseVariablePaths.as"
#include "gameFunctions/nestedEval.as"
	// evalPath
	// resolveContainer
	// getImpliedValue
define_if = function(command_obj)
{
	command_obj.run = function( thisCommand_obj )
	{
		var data = thisCommand_obj.data;
		
		// resolve target variable
		// parse any embedded variable paths
		var target_str = nestedEval( data.condition[0], "RAM", "_this" );
		var target = evalPath( target_str, "RAM", "_this" );
		//var target = getImpliedValue( target );		// convert string to appropriate datatype if neccessary
		
		// resolve value
		var thisValue = getImpliedValue(data.condition[2]);				// skip path detection if it's a non-string value
		
		// parse any embedded variable paths
		thisValue = nestedEval( thisValue, "RAM", "_this" );
		var value = getImpliedValue( thisValue );
		
		
		// test the condition
		var conditionIsTrue = false;
		switch(data.condition[1])
		{
			case "=":
				var conditionIsTrue = (target == value);
			break;
			case "!=":
				var conditionIsTrue = (target != value);
			break;
			case ">":
				if( isNaN(target)==false  &&  isNaN(value)==false )			// both target & value must be numbers
					var conditionIsTrue = (target > value);
			break;
			case ">=":
				if( isNaN(target)==false  &&  isNaN(value)==false )			// both target & value must be numbers
					var conditionIsTrue = (target >= value);
			break;
			case "<":
				if( isNaN(target)==false  &&  isNaN(value)==false )			// both target & value must be numbers
					var conditionIsTrue = (target < value);
			break;
			case "<=":
				if( isNaN(target)==false  &&  isNaN(value)==false )			// both target & value must be numbers
					var conditionIsTrue = (target <= value);
			break;
		}// switch:  operator
		
		if(TRACE_SCRIPT){
			trace("if:  "+data.condition[0]+" "+data.condition[1]+" "+data.condition[2]);
			trace("\t ("+target+" "+data.condition[1]+" "+value+")"+"  ("+conditionIsTrue+")");
		}
		
		if(conditionIsTrue  &&  data.length>0)
		{// if:  condition is true  &  there are commands inside the "if" statement
			// detect when inner script finishes and run external sibling command
			thisCommand_obj.script.done = function(){
				thisCommand_obj.nextEvent();
			}// done()
			
			// run child event
			thisCommand_obj.script.runEvent(0);
		}// if:  condition is true
		else
		{// if:  condition is false
			thisCommand_obj.nextEvent();		// skip this command and continue the script
		}// if:  condition is false
		
	}// run()
}// define_if()